security:
  encoders:
    App\Entity\User:
      algorithm: argon2i
  # https://symfony.com/doc/current/security.html#where-do-users-come-from-user-providers
  providers:
    #users_in_memory: { memory: null }
    app_user_provider:
      entity:
        class: App\Entity\User
        property: username

  firewalls:
    dev:
      pattern: ^/(_(profiler|wdt)|css|images|js)/
      security: false

    login:
      pattern: ^/api/login
      stateless: true
      anonymous: true
      provider: app_user_provider
      json_login:
        check_path: /api/login
    #    success_handler: lexik_jwt_authentication.handler.authentication_success
    #    failure_handler: lexik_jwt_authentication.handler.authentication_failure

    #main:
    #  anonymous: true
    #  lazy: true
    #  provider: app_user_provider
    #  json_login:
    #    check_path: api_login

    api:
      pattern: ^/api
      stateless: true
      anonymous: true
      guard:
        authenticators:
          - lexik_jwt_authentication.jwt_token_authenticator

  # activate different ways to authenticate
  # https://symfony.com/doc/current/security.html#firewalls-authentication

  # https://symfony.com/doc/current/security/impersonating_user.html
  # switch_user: true

  # Easy way to control access for large sections of your site
  # Note: Only the *first* access control that matches will be used
  access_control:
    # - { path: ^/admin, roles: ROLE_ADMIN }
    # - { path: ^/profile, roles: ROLE_USER }
    #- {
    #    path: ^/api/users,
    #    roles: IS_AUTHENTICATED_FULLY,
    #    methods: [PUT, PATCH, DELETE],
    #  }
